from OpenGL.GL import *
import pygame


class Texture:

    def getsize(self):
        return self.size

    def bindme(self):
        glBindTexture(GL_TEXTURE_2D,self.texture)

    def render(self):

        glColor3fv((1.0,1.0,1.0))
        glBindTexture(GL_TEXTURE_2D,self.texture)
        glCallList(self.list)


    def validsize(self,n):

        ok = 2
        while ok<n: ok = ok << 1
        return ok


    def __init__(self, surface, offset):

        X = self.validsize(surface.get_width())
        Y = self.validsize(surface.get_height())
        W = float(surface.get_width())
        H = float(surface.get_height())
        
        self.bitmask = pygame.mask.from_surface(surface)

        self.size = (X,Y)
        self.surf = (W,H)
        self.offset = offset

        ok = pygame.Surface((X,Y),pygame.SRCALPHA,32)
        ok.blit(surface,(0,0))
    
        self.textureData = pygame.image.tostring(ok, "RGBA", 1)

    def regenerate(self):

        X = self.size[0]
        Y = self.size[1]
        W = self.surf[0]
        H = self.surf[1]

        self.texture = glGenTextures(1)
    
        glBindTexture(GL_TEXTURE_2D, self.texture)
        glTexImage2D( GL_TEXTURE_2D, 0, 4, X, Y, 0,
                      GL_RGBA, GL_UNSIGNED_BYTE, self.textureData )
        
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST)

        U = W/X
        V = -H/Y
        
        self.list = glGenLists(1)
        glNewList(self.list,GL_COMPILE)
        glBegin(GL_QUADS)
        glTexCoord2f(0.0, 0.0); glVertex2f( 0.0,  0.0)
        glTexCoord2f(U, 0.0); glVertex2f( W, 0.0)   
        glTexCoord2f(U, V); glVertex2f( W, H)   
        glTexCoord2f(0.0, V); glVertex2f( 0.0, H)   
        glEnd()
        glEndList()

 
        

